/* eslint-disable */
<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%; user-select: none;">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-email-plus</v-icon
            ><b>Nova Mensagem</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <v-card-text class="px-4 mt-n5">
        <!-- {{ this.message.sendTo }} -->
        <v-form ref="form" v-model="valid">
          <v-container>
            <v-row no-gutters>
              <v-col cols="12" class="mt-n1">
                <v-text-field
                  autofocus
                  v-model="message.title"
                  label="Título"
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
              <v-col cols="12" class="mt-n1">
                <select-message-to
                  @selectedIds="selectedIdsToMessage"
                  @allParentsActive="selectedAllParentsToMessage"
                  @cleanEntities="message.sendTo.entityId = ''"
                  @selectedEntities="selectedEntities"
                />
              </v-col>

              <v-col cols="12">
                <p style="padding-bottom: 5px">Mensagem:</p>
                <section style="position: relative">
                  <editor-menu-bar :editor="editor" v-slot="{ commands, isActive }">
                    <div>
                      <!-- Negrito -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.bold() }"
                            @click="commands.bold"
                          >
                            <v-icon
                              :class="isActive.bold() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.bold() ? 'primary' : 'secondary'"
                              >mdi-format-bold</v-icon
                            >
                          </button>
                        </template>
                        <span>Negrito</span>
                      </v-tooltip>
                      <!-- Italico -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.italic() }"
                            @click="commands.italic"
                          >
                            <v-icon
                              :class="isActive.italic() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.italic() ? 'primary' : 'secondary'"
                              >mdi-format-italic</v-icon
                            >
                          </button>
                        </template>
                        <span>Itálico</span>
                      </v-tooltip>
                      <!-- Underline -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.underline() }"
                            @click="commands.underline"
                          >
                            <v-icon
                              :class="isActive.underline() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.underline() ? 'primary' : 'secondary'"
                              >mdi-format-underline</v-icon
                            >
                          </button>
                        </template>
                        <span>Sublinhar</span>
                      </v-tooltip>
                      <!-- Riscar -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.strike() }"
                            @click="commands.strike"
                          >
                            <v-icon
                              :class="isActive.strike() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.strike() ? 'primary' : 'secondary'"
                              >mdi-format-strikethrough</v-icon
                            >
                          </button>
                        </template>
                        <span>Riscar</span>
                      </v-tooltip>

                      <!-- Heading1 -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.heading({ level: 1 }) }"
                            @click="commands.heading({ level: 1 })"
                          >
                            <v-icon
                              :class="
                                isActive.heading({ level: 1 }) ? 'menuBarSelected' : 'menuBarNot'
                              "
                              :color="isActive.heading({ level: 1 }) ? 'primary' : 'secondary'"
                              >mdi-format-header-1</v-icon
                            >
                          </button>
                        </template>
                        <span>Cabeçalho H1</span>
                      </v-tooltip>
                      <!-- Heading2 -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.heading({ level: 2 }) }"
                            @click="commands.heading({ level: 2 })"
                          >
                            <v-icon
                              :class="
                                isActive.heading({ level: 2 }) ? 'menuBarSelected' : 'menuBarNot'
                              "
                              :color="isActive.heading({ level: 2 }) ? 'primary' : 'secondary'"
                              >mdi-format-header-2</v-icon
                            >
                          </button>
                        </template>
                        <span>Cabeçalho H2</span>
                      </v-tooltip>
                      <!-- Heading3 -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.heading({ level: 3 }) }"
                            @click="commands.heading({ level: 3 })"
                          >
                            <v-icon
                              :class="
                                isActive.heading({ level: 3 }) ? 'menuBarSelected' : 'menuBarNot'
                              "
                              :color="isActive.heading({ level: 3 }) ? 'primary' : 'secondary'"
                              >mdi-format-header-3</v-icon
                            >
                          </button>
                        </template>
                        <span>Cabeçalho H3</span>
                      </v-tooltip>
                      <!-- BulletList -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.bullet_list() }"
                            @click="commands.bullet_list"
                          >
                            <v-icon
                              :class="isActive.bullet_list() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.bullet_list() ? 'primary' : 'secondary'"
                              >mdi-format-list-bulleted</v-icon
                            >
                          </button>
                        </template>
                        <span>Lista</span>
                      </v-tooltip>
                      <!-- OrderedList -->
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.ordered_list() }"
                            @click="commands.ordered_list"
                          >
                            <v-icon
                              :class="isActive.ordered_list() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.ordered_list() ? 'primary' : 'secondary'"
                              >mdi-format-list-numbered</v-icon
                            >
                          </button>
                        </template>
                        <span>Lista Numérica</span>
                      </v-tooltip>
                      <!-- Link -->

                      <v-dialog v-model="linkMenuIsActive" persistent width="450px">
                        <dialog-url
                          @closeUrlDialog="linkMenuIsActive = false"
                          @linkUrl="linkUrlChanged"
                        />
                      </v-dialog>
                      <v-tooltip bottom nudge-bottom="-8">
                        <template v-slot:activator="{ on }">
                          <button
                            type="button"
                            v-on="on"
                            class="menubar__button"
                            :class="{ 'is-active': isActive.link() }"
                            @click="openLinkUrl(commands.link, isActive.link())"
                          >
                            <v-icon
                              :class="isActive.link() ? 'menuBarSelected' : 'menuBarNot'"
                              :color="isActive.link() ? 'primary' : 'secondary'"
                              >mdi-link-variant</v-icon
                            >
                          </button>
                        </template>
                        <section style="text-align: center;">
                          Adicionar Link
                          <br />
                          <div style="font-size:0.7rem; margin-top: -8px">
                            (Selecione o texto e click)
                          </div>
                        </section>
                      </v-tooltip>
                    </div>
                  </editor-menu-bar>
                </section>
                <editor-content
                  id="editor-box"
                  class="editor-box"
                  :editor="editor"
                  v-model="editor.content"
                />
              </v-col>
              <v-col cols="11">
                <v-row align="center" style="height: 100%" no-gutters>
                  <section v-if="attachmentList.length > 0">
                    <v-chip
                      v-for="(file, index) in attachmentList"
                      :key="index"
                      small
                      class="mr-1"
                      close
                      @click:close="cancelAttach(index)"
                    >
                      <span v-if="file.name.substring(0, file.name.indexOf('.')).length <= 15"
                        >{{ file.name }} ({{ (file.size / 1024).toFixed(2) }}KB)</span
                      >
                      <span v-else
                        >{{ file.name.substring(0, 14)
                        }}{{ file.name.substring(file.name.length - 4, file.name.length) }} ({{
                          (file.size / 1024).toFixed(2)
                        }}KB)</span
                      >
                    </v-chip>
                  </section>
                  <span
                    v-if="failedMsgAttach"
                    style="display:block; font-size:0.7rem"
                    class="red--text"
                    >{{ failedMsgAttach }}</span
                  >
                </v-row>
              </v-col>
              <v-col :style="this.attachmentList.length == 3 && 'pointer-events:none'" cols="1">
                <v-row justify="end" no-gutters>
                  <v-tooltip
                    v-if="!this.message.sendTo.entityId"
                    color="primary"
                    bottom
                    nudge-bottom="-5"
                  >
                    <template v-slot:activator="{ on }">
                      <div style="width: 24px" v-on="on">
                        <v-file-input
                          class="attach ma-0"
                          style="max-width: 30px;"
                          v-model="attachment"
                          dense
                          @change="selectedAttach"
                        />
                      </div>
                    </template>
                    <section style="text-align: center; line-height: 1.1rem">
                      <p>Anexar Arquivos</p>
                      <span style="font-size: 0.7rem">(Máximo 3 arquivos)</span>
                    </section>
                  </v-tooltip>
                </v-row>
              </v-col>
              <v-col cols="12">
                <v-row class="mb-n3" no-gutters>
                  <v-checkbox
                    style="width: 160px"
                    v-model="schedule"
                    label="Agendar envio?"
                    dense
                    hide-details
                    class="ma-0"
                  ></v-checkbox>
                  <!-- Show Label Schedule Msg -->
                  <v-text-field
                    style="max-width: 200px"
                    class="pa-0 ma-0"
                    v-if="schedule"
                    v-model="message.schedule"
                    placeholder="dd/mm/aaaa hh:mm"
                    prepend-icon="mdi-message-text-clock-outline"
                  ></v-text-field>
                </v-row>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions class="mt-n3 pb-6 pr-6">
        <v-spacer />
        <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
        <v-btn color="primary" elevation="0" @click="handleNewMessage" :disabled="!message.title"
          >Enviar</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-row>
</template>

<script>
import User from '../../services/user'
import DirectMessage from '../../services/directMessage'
import { mapMutations, mapState } from 'vuex'
import { mask } from 'vue-the-mask'
import { Editor, EditorContent, EditorMenuBar } from 'tiptap'
import {
  OrderedList,
  BulletList,
  ListItem,
  Bold,
  Italic,
  Link,
  Strike,
  Underline,
  Heading,
} from 'tiptap-extensions'
import DialogUrl from './DialogUrl.vue'
import SelectMessageTo from './SelectMessageTo.vue'

export default {
  name: 'NewMessage',
  components: {
    SelectMessageTo,
    DialogUrl,
    EditorContent,
    EditorMenuBar,
  },
  directives: {
    mask,
  },
  data: () => ({
    //tiptap plugin
    editor: new Editor({
      content: '',
      extensions: [
        new Bold(),
        new Italic(),
        new Strike(),
        new Underline(),
        new Link(),
        new Heading({ levels: [1, 2, 3] }),
        new ListItem(),
        new BulletList(),
        new OrderedList(),
      ],
    }),
    linkCommand: null,
    linkMenuIsActive: false,
    message: {
      sendBy: '',
      sendTo: { users: [], entityId: '' },
      title: '',
      // subject: { message: '', attachments: null },
      subject: { message: '' },
      schedule: '',
      sendDate: 0,
      hasAttachment: false,
    },
    attachment: null,
    attachmentList: [],
    failedMsgAttach: '',
    uploadSuccess: 0,
    schedule: false,
    date: null,
    mask: '##/##/####',
    valid: false,
    showAll: [{ name: '', id: '' }],
    showUsers: { page: 1, totalItems: 0 },
  }),
  beforeDestroy() {
    this.editor.destroy()
  },
  computed: {
    ...mapState('user', ['msgText']),
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },
  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },

  created() {},
  methods: {
    ...mapMutations('user', ['UPDATE_MSG_TEXT']),

    //INICIO INTEGRAÇÃO BACKEND
    //método sendMessage: envia msg mala direta
    async newMessage() {
      const userId = await this.$getItem('userInfo')
      this.message.sendBy = userId.id
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('directMessageCreate').id
      const date = new Date().getTime()
      this.message.sendDate = date

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await DirectMessage.createMessage(entityId, actionId, this.message)

        if (ret.success && this.attachmentList.length == 0) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Mensagem <b>enviada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }

        if (this.attachmentList.length > 0 && ret.success) {
          console.log(ret.data)
          this.attachmentList.forEach(async (file, index) => {
            await this.uploadFile(ret.data[0].id, file)
          })
        }
      } catch (e) {
        console.log(e)
      }
    },

    async uploadFile(idMessage, file) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const formData = new FormData()
        formData.append('localFile', file)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('directMessageCreate').id
        let ret = await DirectMessage.attachFile(
          routedEntity.id,
          actionId,
          idMessage,
          file.name,
          formData
        )
        if (ret.success) {
          this.uploadSuccess += 1
        }
        if (this.uploadSuccess == this.attachmentList.length) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Mensagem <b>enviada</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (error) {
        console.error('TCL: addLocalFile -> error', error)
      }
    },

    //FIM INTEGRAÇÃO BACKEND

    // APENAS MÉTODOS TELA SEM INTEGRAÇÃO COM BACKEND

    // INICIO ANEXAR
    selectedAttach() {
      this.failedMsgAttach = ''
      const validFormat = [
        'png',
        'jpeg',
        'jpg',
        'bmp',
        'pdf',
        'xls',
        'xml',
        'pptx',
        'ppt',
        'doc',
        'docx',
      ]
      if (this.attachment) {
        const nameFile = this.attachment.name
        const fileExtension = nameFile.substring(nameFile.indexOf('.') + 1, nameFile.length)
        const checkFormat = validFormat.includes(fileExtension)

        if (!checkFormat) {
          this.failedMsgAttach = `Formato .${fileExtension} não é válido`
        }

        if (this.attachment !== undefined && checkFormat) {
          this.attachmentList.push(this.attachment)
        }
      }

      this.attachment = null
    },
    cancelAttach(index) {
      this.attachmentList.splice(index, 1)
    },
    //FIM ANEXAR

    //INICIO BOTAO INSERIR HYPERLINK

    openLinkUrl(command, condition) {
      //condition = se o texto selecionado tem link, retorna true.

      let checkSelected = window.getSelection().isCollapsed
      //checkSelected = false (tem algo selecionado)
      //checkSelected = true (não tem nada selecionado)

      if (!checkSelected && !condition) {
        this.linkMenuIsActive = true
        this.linkCommand = command
      } else {
        this.setLinkUrl(command, null)
      }
    },
    setLinkUrl(command, url) {
      command({ href: url })
    },
    //recebe do dialog o endereço da url
    linkUrlChanged(item) {
      this.setLinkUrl(this.linkCommand, item)
      this.linkMenuIsActive = false
    },

    //FIM BOTAO INSERIR HYPERLINK

    handleClose() {
      this.$emit('closeDialog')
      this.editor.clearContent()
      this.uploadSuccess = 0
      this.failedMsgAttach = ''
      this.attachmentList = []
      let message = {
        sendBy: '',
        title: '',
        subject: { message: '' },
        schedule: '',
        sendDate: 0,
        hasAttachment: false,
      }
      Object.assign(this.message, message)
      this.$store.commit('user/UPDATE_RESET_MAIL_TO', true)
    },
    //clica no botão de enviar mala direta
    async handleNewMessage() {
      this.message.subject.message = this.editor.getHTML()

      if (this.message.subject.message == '<p></p>') {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: 'Não é possível enviar uma mensagem vazia!',
          icon: 'mdi-close-circle',
          color: 'red',
        })
        return
      }

      if (this.message.sendTo.users.length == 0 && !this.message.sendTo.entityId) {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: 'Atenção, selecione alguém para enviar a mensagem.',
          icon: 'mdi-close-circle',
          color: 'red',
        })
        return
      }

      const routedEntity = await this.$getItem('routedEntity')
      const entity = routedEntity.name
      if (this.message.sendTo.entityId) {
        this.message.title = `[${entity}] ` + this.message.title
        this.message.subject.message =
          this.message.subject.message +
          ` <br><p><i>Essa mensagem foi enviada a partir da entidade: <b>${entity}</b></i></p>`
      }

      await this.newMessage()
      this.$emit('sendedMsg')
      this.$store.commit('user/UPDATE_RESET_MAIL_TO', true)
    },

    selectedIdsToMessage(ids) {
      this.message.sendTo.users = ids
      if (this.message.sendTo.users.length > 0) this.message.sendTo.entityId = ''
    },

    selectedAllParentsToMessage(entities) {
      let idEntities = entities.map((entity) => {
        return entity.id
      })
      this.message.sendTo.users = []
      this.message.sendTo.entityId = idEntities
    },

    selectedEntities(entities) {
      this.message.sendTo.entityId = ''
      this.message.sendTo.users = []
      this.message.sendTo.entityId = entities
    },
  },
}
</script>

<style>
.attach > .v-input__control {
  display: none !important;
}
.ProseMirror {
  margin-top: 10px;
  margin-bottom: 10px;
  padding: 8px;
  color: #000;
  border: 1px solid #808080;
  border-radius: 0.2rem;
  min-height: 140px;
  max-height: 140px;
  overflow-y: auto;
}

.ProseMirror:focus {
  outline: none;
  border: 1px solid #2a0845 !important;
}

.menubar__button {
  outline: none;
  padding-right: 4px;
}

.menuBarSelected {
  background: #ccc;
  border: 1px solid #ccc;
  border-radius: 0.2rem;
  padding: 2px;
}
.menuBarNot {
  background: none;
  border: 1px solid #808080;
  border-radius: 0.2rem;
  padding: 2px;
}
p {
  margin: 0rem !important;
}

ul > li > p {
  margin: 0 !important;
}

ol > li > p {
  margin: 0 !important;
}
.deleteTitleFont {
  transform: scale(0.75);
}
.iconTitle {
  padding-top: 15px;
  transform: scale(1.5);
}
.upload {
  padding-top: 15px;
  padding-bottom: 25px;
  transform: scale(1.5);
}
.sub {
  font-size: 1.3em;
}
.iconPosition {
  padding-top: 35px;
}
</style>
